# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::AzureStackHCI::Mgmt::V2020_03_01_preview
  module Models
    #
    # Cluster node details.
    #
    class ClusterNode

      include MsRestAzure

      # @return [String] Name of the cluster node.
      attr_accessor :name

      # @return [Float] Id of the node in the cluster.
      attr_accessor :id

      # @return [String] Manufacturer of the cluster node hardware.
      attr_accessor :manufacturer

      # @return [String] Model name of the cluster node hardware.
      attr_accessor :model

      # @return [String] Operating system running on the cluster node.
      attr_accessor :os_name

      # @return [String] Version of the operating system running on the cluster
      # node.
      attr_accessor :os_version

      # @return [String] Immutable id of the cluster node.
      attr_accessor :serial_number

      # @return [Float] Number of physical cores on the cluster node.
      attr_accessor :core_count

      # @return [Float] Total available memory on the cluster node (in GiB).
      attr_accessor :memory_in_gi_b


      #
      # Mapper for ClusterNode class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ClusterNode',
          type: {
            name: 'Composite',
            class_name: 'ClusterNode',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'Double'
                }
              },
              manufacturer: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'manufacturer',
                type: {
                  name: 'String'
                }
              },
              model: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'model',
                type: {
                  name: 'String'
                }
              },
              os_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'osName',
                type: {
                  name: 'String'
                }
              },
              os_version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'osVersion',
                type: {
                  name: 'String'
                }
              },
              serial_number: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'serialNumber',
                type: {
                  name: 'String'
                }
              },
              core_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'coreCount',
                type: {
                  name: 'Double'
                }
              },
              memory_in_gi_b: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'memoryInGiB',
                type: {
                  name: 'Double'
                }
              }
            }
          }
        }
      end
    end
  end
end
